function [theta1,thetaM,eigenanalyses]=refinar_real(A,J,Tol,thetaM,N,eigenanalyses)

% disp('Subrotine of the main file Jnumrange_main_routine.m');
% disp(' ')
% disp('Programmer: Ana Nata');
% disp('e-mail: anata@ipt.pt')
% disp(' ');
% disp('December 2013')
% disp(' ')
% disp('This subroutine is the implementation of the subsection 4.1 of the')
% disp('article (Step1), when A is a real matrix')

%%
%Computation of thetaM
[VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM);      
eigenanalyses=eigenanalyses+1;
k=2;
thetaM_ref=thetaM;
    while (interlaM~=2 || auxM~=1) &&  thetaM_ref>Tol
        thetaM_ref=pi/(2^k);
        [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM_ref);
        eigenanalyses=eigenanalyses+1;
        k=k+1;
    end
l=k-1;
[VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM_ref+pi/(2^(l)));
    if l<=N && (interlaM~=2 || auxM~=1)
        theta=pi/(2^l);
        thetaM=theta;
        if l<=N 
            s=1;
            thetaM_ref=theta+pi/(2^(l+s));
            [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM_ref);
            eigenanalyses=eigenanalyses+1;
            s=2;
                while (interlaM~=2 || auxM~=1) &&  thetaM_ref>Tol
                    thetaM_ref=theta+pi/(2^(l+s));
                    [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM_ref);
                    eigenanalyses=eigenanalyses+1;
                    s=s+1;
                end
            r=s-1;
            [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM_ref+pi/(2^(l+r)));
                if l+r<=N && (interlaM~=2 || auxM~=1)
                    theta=theta+pi/(2^(l+r));
                    thetaM=theta;
                        while l+r<=N  
                            t=1;
                            thetaM_ref=theta+pi/(2^(l+r+t));
                            [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM_ref);
                            eigenanalyses=eigenanalyses+1;
                            t=2;
                                while (interlaM~=2 || auxM~=1) &&  thetaM_ref>Tol
                                    thetaM_ref=theta+pi/(2^(l+r+t));
                                    [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM_ref);
                                    eigenanalyses=eigenanalyses+1;
                                    t=t+1;
                                end
                            l=l+r;
                            r=t-1;
                            if l+r<=N
                                theta=theta+pi/(2^(l+r));
                                thetaM=theta;
                            else
                                break
                            end
                        end
                end
        end
    end
theta1=-thetaM; %Computation of theta1, because A is a real matrix
    

    
    
    
