function [auxini,theta1,thetaM,center,eigenanalyses,k1,k2,kc,s1,s2]=center_complex(A,J,Tol,eigenanalyses)

% disp('Subrotine of the main file Jnumrange_main_routine.m');
% disp(' ')
% disp('Programmer: Ana Nata');
% disp('e-mail: anata@ipt.pt')
% disp(' ');
% disp('December 2013')
% disp(' ')
% disp('This subroutine is the implementation of the subsection 4.1 of the')
% disp('article)

%%
theta1_first=-pi/2;thetaM_first=pi/2;
auxini=1;
k1=0;k2=0;kc=0;s1=0;s2=0;
[VP1M VP2M interla0 aux0]=theta1_e_thetaM(A,J,Tol,0);      
    if interla0==2 && aux0==1 %For the direction theta=0, the eigenvalues of the 
        %J-Hermitian matrix T=Re^J(e^(-itheta)A) are all real, don't interlace')
        %and with anisotropic eigenvectors
        auxini=0; %non degenerate
        %Computation of thetaM
        thetaM=thetaM_first;
        [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM);      
        eigenanalyses=eigenanalyses+1;
        k1=2;
            while (interlaM~=2 || auxM~=1) &&  thetaM>Tol 
                for s=1:k1
                    if mod(s,2)==1 && (interlaM~=2 || auxM~=1) &&  thetaM>Tol
                        thetaM=s*pi/(2^k1);
                        [VP1M VP2M interlaM auxM]=theta1_e_thetaM(A,J,Tol,thetaM);
                        eigenanalyses=eigenanalyses+1;
                        s1=s;
                    elseif (interlaM==2 && auxM==1) &&  thetaM>Tol
                        break;
                    end
                end
                k1=k1+1;
            end
        %Computation of theta1
        theta1=theta1_first;
        [VP11 VP21 interla1 aux1]=theta1_e_thetaM(A,J,Tol,theta1);      
        eigenanalyses=eigenanalyses+1;
        k2=2;
            while (interla1~=2 || aux1~=1) &&  theta1<-Tol
                for s=1:k2
                    if mod(s,2)==1 && (interla1~=2 || aux1~=1) &&  theta1<-Tol
                        theta1=-s*pi/(2^k2);
                        [VP11 VP21 interla1 aux1]=theta1_e_thetaM(A,J,Tol,theta1);
                        eigenanalyses=eigenanalyses+1;
                        s2=s;
                    elseif (interla1==2 && aux1==1) &&  theta1<-Tol
                        break;
                    end
                end
                k2=k2+1;
            end    
        center=0;
    else %For the direction theta=0, the eigenvalues of the J-Hermitian matrix T=Re^J(e^(-itheta)A)
        %are not all real, or interlace or have anisotropic eigenvectors
        %Computation of the center
        center=thetaM_first;
        [VP1c VP2c interlac auxc]=theta1_e_thetaM(A,J,Tol,center);
        if interlac==2 && auxc==1
            auxini=0;
        else
            eigenanalyses=eigenanalyses+1;
            kc=2;
                while (interlac~=2 || auxc~=1) &&  center>Tol 
                    for s=1:kc
                        if mod(s,2)==1 && (interlac~=2 || auxc~=1) &&  center>Tol
                            center=s*pi/(2^kc);
                            [VP1c VP2c interlac auxc]=theta1_e_thetaM(A,J,Tol,center);
                            eigenanalyses=eigenanalyses+1;
                        elseif (interlac==2 && auxc==1) &&  center>Tol
                            auxini=0;
                            break;
                        end
                    end
                    kc=kc+1;
                end
        end
                if center<=Tol 
                    center=theta1_first;
                    [VP1c VP2c interlac auxc]=theta1_e_thetaM(A,J,Tol,center);
                        if interlac==2 && auxc==1
                            auxini=0;
                        else
                            eigenanalyses=eigenanalyses+1;
                            kc=2;
                                while (interlac~=2 || auxc~=1) &&  center<-Tol
                                    for s=1:kc
                                        if mod(s,2)==1 && (interlac~=2 || auxc~=1) &&  center<-Tol
                                            center=-s*pi/(2^kc);
                                            [VP1c VP2c interlac auxc]=theta1_e_thetaM(A,J,Tol,center);
                                            eigenanalyses=eigenanalyses+1;
                                        elseif (interlac==2 && auxc==1) &&  center<-Tol
                                            auxini=0;
                                            break;
                                        end
                                    end
                                    kc=kc+1;
                                end
                        end
                end
        theta1=center;thetaM=center; %because we are going to refine this values
    end
end
    


     
    

   
