function [interla]=interlating(D1,D2,Tol)

% disp('Subrotine of the main file Jnumrange_main_routine.m');
% disp(' ')
% disp('Programmer: Ana Nata');
% disp('e-mail: anata@ipt.pt')
% disp(' ');
% disp('December 2013')
% disp(' ')
% disp('This subroutine check if the elements of D1 and D2 are (or aren't)';
% disp('interlaced');

%%
d1=sort((real(D1)),'descend'); %Sort the elements of D1 by descending order
d2=sort((real(D2)),'descend'); %Sort the elements of D2 by descending order

if size(d1,2)==1 && size(d2,2)==1
    if abs(d1-d2)<Tol
        interla=1; %exist interlacement
    else
        interla=2; % there not exist interlacement
    end
elseif size(d1,2)==0 || size(d2,2)==0
        interla=1;
else
    if real(d1(size(d1,2)))>real(d2(1,1)) || real(d2(size(d2,2)))>real(d1(1,1))
        interla=2; % there not exist interlacement 
    else
        interla=1; % there exist interlacement
    end
end

