function [X,Y]=ortog(X1,Y1,J)

% disp('Subrotine of the main file Jnumrange_main_routine.m');
% disp(' ')
% disp('Programmer: Ana Nata');
% disp('e-mail: anata@ipt.pt')
% disp(' ');
% disp('December 2013')
% disp(' ')
% disp('This subroutine make the J-orthonormalization to the vectors X1 and Y1')

%%
%J-orthogonalization process
X2=X1;
Y2=Y1-(X1'*J*Y1)*X1/(X1'*J*X1);

%J-normalizarion of the vectors
if sqrt(X2'*J*X2)~=0 && sqrt(Y2'*J*Y2)~=0
    X=X2*(1/sqrt(X2'*J*X2));
    Y=Y2*(1/sqrt(Y2'*J*Y2));
end